#include <Eigen/Core>
#include "stiffness_matrix.hpp"
#include "fem_solve.hpp"
#include "writer.hpp"
#include "convergence.hpp"
#include <sstream>
#include "square.hpp"
#include "Lshape.hpp"





int main(int, char**) {
    try {
        solveSquare();
	solveL();
 //       convergenceAnalysis("square", 7, f_square, g_square, g_square);
        convergenceAnalysis("Lshape", 7, f_lshape, g_lshape, g_lshape,g_grad_lshape);

    }
    catch (std::runtime_error& e) {
        std::cerr << "An error occurred. Error message: " << std::endl;
        std::cerr << "    \"" << e.what() << "\"" << std::endl;
        return EXIT_FAILURE;
    } 
    catch (...) {
        std::cerr << "An unknown error occurred." << std::endl;
        throw ;
    }

    return EXIT_SUCCESS;

}
