#pragma once
#include <iostream>
#include <Eigen/Core>
#include <igl/readMESH.h>
#include <igl/readDMAT.h>
#include "writer.hpp"
#include "fem_solve.hpp"

double f_square(double x, double y) {
    return 8 * M_PI * M_PI * cos(M_PI *x) * cos(M_PI * y);
}

double g_square(double x, double y) {
    return cos(M_PI *x) * cos(M_PI * y);
}

void solveSquare_bd() {
    std::cout << "Solving square" << std::endl;
    Vector u;

    Eigen::MatrixXd vertices;
    Eigen::MatrixXi triangles;
    Eigen::MatrixXi tetrahedra;

    igl::readMESH(CMEA2_DATA_PATH "square_5.mesh", vertices, tetrahedra, triangles);

    solveFiniteElement(u, vertices, triangles, f_square, g_square);

    writeToFile("square_5_values.txt", u);
    writeMatrixToFile("square_5_vertices.txt", vertices);
    writeMatrixToFile("square_5_triangles.txt", triangles);
}
