#pragma once
#include <Eigen/Core>
#include <Eigen/Sparse>
#include <vector>

#include "stiffness_matrix.hpp"

//! Sparse Matrix type. Makes using this type easier.
typedef Eigen::SparseMatrix<double> SparseMatrix;

//! Used for filling the sparse matrix.
typedef Eigen::Triplet<double> Triplet;


//! Assemble the stiffness matrix
//! for the linear system
//!
//! @param[out] A will at the end contain the Galerkin matrix
//! @param[in] vertices a list of triangle vertices
//! @param[in] triangles a list of triangles
template<class Matrix>
void assembleStiffnessMatrix(Matrix& A, const Eigen::MatrixXd& vertices,
                            const Eigen::MatrixXi& triangles)
{
    // assemble the stiffness matrix here.
    // NOTE: For each triangle i, you can get the
    // three triangle corners (vertices) with:
    //
    // const auto& indexSet = triangles.row(i)
    // const auto& a = vertices.row(indexSet(0))
    // const auto& b = vertices.row(indexSet(1))
    // const auto& c = vertices.row(indexSet(2))
}
